Enable upgrading from 12.04 to 14.04 while keeping ESM enabled

Bug #1824862 reported by Joshua Powers on 2019-04-15
14
This bug affects 1 person
Affects Status Importance Assigned to Milestone
ubuntu-release-upgrader (Ubuntu)
Undecided
Unassigned
Trusty
Undecided
Brian Murray

Bug Description

[Impact]
While it is possible to upgrade from 12.04 w/ ESM enabled to 14.04 the ESM archive is disabled thereby making customers vulnerable (since 14.04 is no long receiving security updates) until they reenable the ESM archive.

[Test Case]
1. run 'sudo ubuntu-advantage enable-esm $USER:$PASSWORD'
2. edit /etc/update-manager/release-upgrades set Prompt=lts
3. run 'do-release-upgrade'
4. observe "third party entries in your sources.list were disabled" message
also check /var/log/dist-upgrade/main.log for the following line:
2019-05-02 10:22:28,345 DEBUG examining: 'deb https://hidden-u:<email address hidden>/ubuntu precise main'
2019-05-02 10:22:28,346 DEBUG entry '# deb https://hidden-u:<email address hidden>/ubuntu trusty main # disabled on upgrade to trusty' was disabled (unknown mirror)

with the version of the release upgrader in -proposed you won't receive the disabled message and will see the following in main.log:
2019-05-02 11:56:58,856 DEBUG examining: 'deb https://hidden-u:<email address hidden>/ubuntu precise-security main'
2019-05-02 11:56:58,856 DEBUG entry 'deb https://hidden-u:<email address hidden>/ubuntu trusty-security main' updated to new dist
(Yes, that really says precise-security it's part of the hack to switch pockets.)

[Regression Potential]
Because the sources.list entries are manipulated to switch pockets from the precise release one to trusty -security and -updates is possible this change would persist if someone were to cancel the upgrade. So we should test that cancelling the upgrade doesn't modify (by switching pockets) your /etc/apt/sources.list.d/esm* file.

We now have an LTS to LTS where both have ESM. Therefore we should be testing a system with ESM installed on Precise and then upgrade to Trusty ESM.

Related branches

tags: added: id-5cb7b8f326bdd652e255d828
Brian Murray (brian-murray) wrote :

Currently it does not work.

2019-04-23 22:33:22,915 DEBUG examining: 'deb https://hidden-u:<email address hidden>/ubuntu-esm/esm/ubuntu precise main #Personal access of Brian M
urray (brian-murray) to Extended Security Maintenance'
2019-04-23 22:33:22,917 DEBUG entry '# deb https://hidden-u:<email address hidden>/ubuntu-esm/esm/ubuntu trusty main #Personal access of Brian Murra
y (brian-murray) to Extended Security Maintenance disabled on upgrade to trusty' was disabled (unknown mirror)

Brian Murray (brian-murray) wrote :

This fixable by adding the following line to mirrors.cfg in the release upgrader:

https://private-ppa.launchpad.net/ubuntu-esm/esm/ubuntu

I don't think you should have to add the "/esm/ubuntu" part but its the least invasive change.

Julian Andres Klode (juliank) wrote :

That's the wrong URL for ESM, the correct one is esm.ubuntu.com/ubuntu

$ cat /etc/apt/sources.list.d/ubuntu-esm-precise.list | sed 's#://.*@#://USER:PASSWORD@#'
deb https://USER:<email address hidden>/ubuntu precise main
# deb-src https://USER:<email address hidden>/ubuntu precise main

Brian Murray (brian-murray) wrote :

Testing an upgrade from Ubuntu 12.04 w/ ESM enabled to Ubuntu 14.04 I've discovered that the upgrade is calculatable if esm.ubuntu.com is not in the mirrors.cfg file which causes the release upgrader to just disable that unknown repository. If mirrors.cfg is modified so that esm.ubuntu.com is listed then the upgrade fails because of the following:

W:Failed to fetch
https://esm.ubuntu.com/ubuntu/dists/trusty/main/binary-amd64/Packages
, W:Failed to fetch
https://esm.ubuntu.com/ubuntu/dists/trusty/main/binary-i386/Packages
, E:Some index files failed to download. They have been ignored, or
old ones used instead.

As I understand it there is no release pocket for the Ubuntu 14.04 ESM archive which makes sense and so the release upgrade fails. Given that the upgrade from Ubuntu 12.04 w/ ESM to plain Ubuntu 14.04 is possible and switching to Ubuntu 14.04 w/ ESM is rather involved it seems like ubuntu-advantage should take care of reenabling ESM if that's what is supposed to happen.

summary: - Test Precise ESM to Trusty ESM
+ Enable upgrading from 12.04 to 14.04 while keeping ESM enabled
Changed in ubuntu-release-upgrader (Ubuntu Trusty):
status: New → In Progress
assignee: nobody → Brian Murray (brian-murray)
description: updated
Changed in ubuntu-release-upgrader (Ubuntu):
status: New → Fix Released

Hello Joshua, or anyone else affected,

Accepted ubuntu-release-upgrader into trusty-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/ubuntu-release-upgrader/1:0.220.11 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-trusty to verification-done-trusty. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-trusty. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in ubuntu-release-upgrader (Ubuntu Trusty):
status: In Progress → Fix Committed
tags: added: verification-needed verification-needed-trusty
Bryan Quigley (bryanquigley) wrote :

Did some testing and a 12.04 do-release-upgrade -p worked fine leaving ESM enabled. I'm not familiar with the full scope of upgrade testing, so leaving as verification-needed.

Brian Murray (brian-murray) wrote :

I also tested an upgrade from 12.04 to 14.04 with ESM enabled and it succeeded in that ESM continued to be enabled after the upgrade.

bdmurray@clean-precise-amd64:~$ grep "release-upgrader version" /var/log/dist-upgrade/main.log
2019-05-06 10:47:09,531 INFO release-upgrader version '0.220.11' started
bdmurray@clean-precise-amd64:~$ grep hidden-u /var/log/dist-upgrade/main.log
2019-05-06 10:47:16,812 DEBUG examining: 'deb https://hidden-u:<email address hidden>/ubuntu precise-updates main'
2019-05-06 10:47:16,812 DEBUG entry 'deb https://hidden-u:<email address hidden>/ubuntu trusty-updates main' updated to new dist
2019-05-06 10:47:16,812 DEBUG examining: 'deb https://hidden-u:<email address hidden>/ubuntu precise-security main'
2019-05-06 10:47:16,812 DEBUG entry 'deb https://hidden-u:<email address hidden>/ubuntu trusty-security main' updated to new dist

tags: added: verification-done verification-done-trusty
removed: verification-needed verification-needed-trusty
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubuntu-release-upgrader - 1:0.220.11

---------------
ubuntu-release-upgrader (1:0.220.11) trusty; urgency=medium

  * DistUpgradeController.py: Handle the transition of ESM during the release
    upgrade. (LP: #1824862)
  * DistUpgrade/build-tarball.sh: include ESM archive's gpg key.
  * mirrors.cfg: add in esm.ubuntu.com as an official mirror, update mirrors.

 -- Brian Murray <email address hidden> Wed, 01 May 2019 15:09:41 -0700

Changed in ubuntu-release-upgrader (Ubuntu Trusty):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for ubuntu-release-upgrader has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers